% prpr01.m
% integration de     dx/dt =  x - x*y    ,     dy/dt =  x*y - y 
%                         schema de Runge et Kutta 
% exemple typique de type 'predateurs et proies' 
% fd, iacs, 19 decembre 2004, 16 janvier 2005, 25 mai 2008.  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('prpr01. Cycle limite non lineaire avec le schema de Runge et Kutta.') ;
title ('Predateurs et proies') ;
n=10 ;  dt=1/n
vec=zeros(2,2) ; lmax = 4 ; 
for l=1:lmax;
if l<=1 ;   hold off ; else ; hold on ; end
if ((l>=1)&(l<=1)) ;  x=1.01  ; y=.99  ; imax = 6*n  ; end ; 
if ((l>=2)&(l<=2)) ;  x=1.1   ; y=.9  ;  imax =  7*n ; end ; 
if ((l>=3)&(l<=3)) ;  x=1     ; y=1.5;   imax = 10*n ; end ;  
if ((l>=4)&(l<=4)) ;  x=.5    ; y=0.5;   imax = 10*n ; end ;
axis ([ .3 , 2.3 , .2 , 2.3  ])
for i=1:imax ;
if (i<=1) ; if (l<=1) ; plot(x , y, '*g;depart;') ; else ; 
 plot(x , y, '*g;;') ;end  ; end ; 
px1 = x - x * y                ;  py1 = x * y - y  ; 
x1  = x +  0.5 *dt * px1       ;  y1  = y + 0.5 * dt * py1 ;
px2 = x1 - x1 * y1             ;  py2 = x1 * y1 - y1  ; 
x2  = x +  0.5 *dt * px2       ;  y2  = y + 0.5 * dt * py2 ;
px3 = x2 - x2 * y2             ;  py3 = x2 * y2 - y2  ; 
x3  = x + dt * px3             ;  y3  = y + dt * py3 ;
px4 = x3 - x3 * y3             ;  py4 = x3 * y3 - y3   ; 
xn  = x + dt * ( px1 + 2*px2 + 2*px3+ px4  ) / 6 ;
yn  = y + dt * ( py1 + 2*py2 + 2*py3+ py4  ) / 6 ;
%
vec(1,1)=x ; vec(2,1)=xn ; 
vec(1,2)=y ; vec(2,2)=yn ;   
hold on 
if ((l>=1)&(l<=1)) ; 
if i<=1 ;   
hold on ; plot ( vec(:,1) , vec(:,2), 'r;trajectoire;') ; else ; 
plot ( vec(:,1) , vec(:,2), 'r;;') ; end ; end ; 
if ((l>=2)&(l<=2)) ; plot ( vec(:,1) , vec(:,2), 'og;;') ; end ; 
if ((l>=3)&(l<=3)) ; plot ( vec(:,1) , vec(:,2), 'b;;') ; end ; 
if ((l>=4)&(l<=4)) ; plot ( vec(:,1) , vec(:,2), 'xm;;') ; end ; 
x=xn ; y=yn ; 
end ; xn , yn 
hold on ;  if (l<=1) ; plot(xn , yn , '*b;arrivee;') ; 
else ;  plot(xn , yn , '*b;;') ;end ; 
if  (l<lmax) ;pause ; end ; end ; hold off ; 
