% vdp4bis.m
% integration de     dx/dt =  y + x - x**3   ,     dy/dt =  -x
%       schema de Runge et Kutta 
% la solution exacte est l attracteur de Van der Pol
% fd, iacs, 19 decembre 2004, 16 janvier 2005, 20 novembre 2006.  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% xlabel ('vdp4. Cycle limite non lineaire avec le schema de Runge et Kutta.') ;
% title ('Oscillateur de Van der Pol') ;
% xtitle ('Cnam Paris. Travaux pratiques Iacs.') ;
n=10 ;  dt=1/n
vec=zeros(2,2) ; lmax = 4 ; 
for l=1:lmax;
if l<=1 ;   hold off ; else ; hold on ; end
if ((l>=1)&(l<=1)) ;  x=0.01 ; y=0 ; imax = 20*n ; end ; 
if ((l>=2)&(l<=2)) ;  x=1    ; y=-1; imax = 10*n ; end ; 
if ((l>=3)&(l<=3)) ;  x=.5   ; y=.5; end ;  
if ((l>=4)&(l<=4)) ;  x=-.5  ; y=0;  end ;
% gset xrange[-1.5: 1.9] ;  gset yrange[-1.7:1.5] ;
axis ([ -1.5 , 1.9,  -1.7 , 1.5 ]) 
for i=1:imax ;
if (i<=1) ; if (l<=1) ; plot(x , y, '*g;;') ; else ; 
 plot(x , y, '*g;;') ;end  ; end ; 
px1 = y + x - x**3             ;  py1 = - x  ; 
x1  = x +  0.5 *dt * px1       ;  y1  = y + 0.5 * dt * py1 ;
px2 = y1 + x1 - x1**3          ;  py2 =   - x1  ; 
x2  = x +  0.5 *dt * px2       ;  y2  = y + 0.5 * dt * py2 ;
px3 = y2 + x2 - x2**3          ;  py3 = - x2  ; 
x3  = x +  0.5 *dt * px3       ;  y3  = y + 0.5 * dt * py3 ;
px4 = y3 + x3 - x3**3          ;  py4 = - x3  ; 
xn  = x + dt * ( px1 + 2*px2 + 2*px3+ px4  ) / 6 ;
yn  = y + dt * ( py1 + 2*py2 + 2*py3+ py4  ) / 6 ;
%
vec(1,1)=x ; vec(2,1)=xn ; 
vec(1,2)=y ; vec(2,2)=yn ;   
hold on 
if ((l>=1)&(l<=1)) ; 
if i<=1 ;   
hold on ; plot ( vec(:,1) , vec(:,2), 'r;trajectoire;') ; else ; 
plot ( vec(:,1) , vec(:,2), 'r;;') ; end ; end ; 
if ((l>=2)&(l<=2)) ; plot ( vec(:,1) , vec(:,2), 'og;;') ; end ; 
if ((l>=3)&(l<=3)) ; plot ( vec(:,1) , vec(:,2), 'b;;') ; end ; 
if ((l>=4)&(l<=4)) ; plot ( vec(:,1) , vec(:,2), 'xm;;') ; end ; 
x=xn ; y=yn ; 
end ; xn , yn 
hold on ;  if (l<=1) ; plot(xn , yn , '*b;arrivee;') ; 
else ;  plot(xn , yn , '*b;;') ; end ; 
if  (l<lmax) ; pause ; end ; end ; 

% gset terminal postscript ;  gset output "courbe.ps" 
plot(xn , yn , '*b;;') ; 