% vdp2.m
% integration de     dx/dt =  y + x - x**3   ,     dy/dt =  -x
%       schema de Heun 
% la solution exacte est l attracteur de Van der Pol
  % fd, iacs, 18 septembre  2004, 22 janvier 2006
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('vdp2. Cycle limite non lineaire avec le schema de Heun.') ;
title ('Oscillateur de Van der Pol') ;
% title ('Cnam Paris. Travaux pratiques Iacs.') ;
n=10 ;  dt=1/n
vec=zeros(2,2) ; 
x=0.01;
y=0;
% gset yrange[-1.5:1.5] ; gset xrange[-1.5: 1.5] ; 
axis ([ -1.5 , 1.5,  -1.5 , 1.5 ]) 
for i=1:25*n;
if i<=1 ;   hold off ; plot(x , y, '*g;depart;') ; end  ; 
px1 =    y + x - x**3    ; py1 =   - x  ; 
x1  = x + dt * px1       ; y1  = y + dt * py1 ;
px2 = y1 + x1 - x1**3     ;   py2 =   - x1  ; 
xn  = x + 0.5 * dt * (px1+px2)   ;   yn  = y +  0.5 * dt * (py1+py2) ;
%
vec(1,1)=x ; vec(2,1)=xn ; 
vec(1,2)=y ; vec(2,2)=yn ; 
if i<=1 ;   
hold on ; plot ( vec(:,1) , vec(:,2), 'r;trajectoire;') ; else ; 
plot ( vec(:,1) , vec(:,2), 'r;;') ; end ; 
x=xn ; y=yn ; 
end ; xn , yn 
hold on ;  plot(xn , yn , '*b;arrivee;') ; hold off ; 
